unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls, Crt;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);

{
Gestohlen hier:
http://www.tutorials.at/pascal/09-dateizugriff.html
}

TYPE Daten = RECORD
       Name: String[50];
       Adresse: String[255];
       Telefonnummer: String[15];
     END;

     Gesamte_Daten = ARRAY [1..100] OF Daten;

VAR Datensatz: Gesamte_Daten;
    i: 1..100;
    Datei: FILE OF Gesamte_Daten;

begin

  ClrScr;

  Assign (Datei, 'daten.dat');
  {$I-} Reset (Datei);   (* Datei zum Lesen oeffnen; die Compilerdirektive verhindert Fehlermeldungen *)
  Read (Datei, Datensatz);  (* die gesamte Struktur einlesen *)
  Close (Datei); {$I+}

  IF IORESULT <> 0 THEN
  BEGIN
    WriteLn ('Fehler beim Lesen der Daten! Ende.');
    Exit;
  END;

  REPEAT

    Write ('Welchen Eintrag verwenden: (1-100; 0 = Programmende) ');
    ReadLn (i);

    IF i = 0 THEN Exit;  (* Programm beenden *)

	(* Wenn Datensatz leer ist, Daten eingeben lassen *)
    IF (Datensatz[i].Name = '') OR (Datensatz[i].Adresse = '') OR (Datensatz[i].Telefonnummer = '') THEN
    BEGIN
      WriteLn ('Eintrag ',i);
      Write ('Name: ');
      ReadLn (Datensatz[i].Name);
      WriteLn ('Adresse:');
      ReadLn (Datensatz[i].Adresse);
      Write ('Telefonnummer: ');
      ReadLn (Datensatz[i].Telefonnummer);
      WriteLn;

      ReWrite (Datei);  (* Datei zum Schreiben oeffnen *)
      Write (Datei, Datensatz);   (* speichern; wichtig: geht nur mit Write! *)
      Close (Datei);
    END
    ELSE  (* Daten anzeigen *)
    BEGIN
      WriteLn ('Name: ',Datensatz[i].Name);
      WriteLn ('Adresse:');
      WriteLn (Datensatz[i].Adresse);
      WriteLn ('Telefonnummer: ',Datensatz[i].Adresse);
    END;

  UNTIL i = 0;   (* So lange wiederholen, bis der Benutzer 0 eingibt *)

  ReadKey;

end;

end.

